/// <reference types="node" />
import dgram, { RemoteInfo } from 'dgram';
import EventEmitter from 'events';
import net from 'net';
import type { Device } from './device';
export default class DeviceNetworking extends EventEmitter {
    address: string;
    device: Device;
    model?: string;
    port: number;
    responseDelay: number;
    server?: net.Server;
    serverBound: boolean;
    udpCb?: (msg: Buffer, rinfo: dgram.RemoteInfo) => void;
    udpSocket?: dgram.Socket;
    udpSocketBound: boolean;
    constructor({ device, model, port, address, responseDelay, }: {
        device: Device;
        model: string;
        port?: number;
        address?: string;
        responseDelay?: number;
    });
    processUdpMessage(msg: Buffer, rinfo: RemoteInfo): void;
    processTcpMessage(msg: Buffer, socket: net.Socket): void;
    start(): Promise<this>;
    stop(): Promise<this>;
}
//# sourceMappingURL=device-networking.d.ts.map